//---------------------------------------------------------------------------
#ifndef Moochos_Restamper_EditMan_H
#define Moochos_Restamper_EditMan_H
//---------------------------------------------------------------------------
// EditMan.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <FileCtrl.hpp>
#include "Lib/Moochos/Moa/Files.h"
#include "Lib/Moochos/Moa/Histories.h"
#include "Lib/Moochos/Moa/Time.h"
//---------------------------------------------------------------------------
namespace Moochos { namespace Restamper { namespace EditMan {
//---------------------------------------------------------------------------
class EEditManError : public Exception
{
public:
	__fastcall EEditManError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TEditMan : public TObject
{
private:
	TValueHistory<TFileTimes>* FFileTimesHistory;
	TOpenDialog* FGetDialog;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall EnterCommandEnter(TObject* ASender, FILETIME& AFileTime, bool& ACanContinue);
	void __fastcall GetCoomandGet1(TObject* ASender, AnsiString& AFileName, bool& ACanContinue);
	void __fastcall GetCoomandGet2(TObject* ASender, AnsiString& AFileName, bool& ACanContinue);
	void __fastcall AddCommandGet(TObject* ASender, LONGLONG& AAmount, bool& ACanContinue);
protected:
public:
	__fastcall TEditMan(TValueHistory<TFileTimes>* AFileTimesHistory);
	virtual __fastcall ~TEditMan();
	void __fastcall EnterCreated(const TFileTimeKinds& AFileTimeKinds, bool ALocalTime);
	void __fastcall EnterLastModified(const TFileTimeKinds& AFileTimeKinds, bool ALocalTime);
	void __fastcall EnterLastAccessed(const TFileTimeKinds& AFileTimeKinds, bool ALocalTime);
	void __fastcall EnterAllTimes(const TFileTimeKinds& AFileTimeKinds, bool ALocalTime);
	void __fastcall GetFromFile(const TFileTimeKinds& AFileTimeKinds, bool ALocalTime);
	void __fastcall GetFromDir(const TFileTimeKinds& AFileTimeKinds, bool ALocalTime);
	void __fastcall ResetToCreated(const TFileTimeKinds& AFileTimeKinds, bool ALocalTime);
	void __fastcall ResetToLastModified(const TFileTimeKinds& AFileTimeKinds, bool ALocalTime);
	void __fastcall ResetToLastAccessed(const TFileTimeKinds& AFileTimeKinds, bool ALocalTime);
	void __fastcall SetToNow(const TFileTimeKinds& AFileTimeKinds, bool ALocalTime);
	void __fastcall IncrementDate(const TFileTimeKinds& AFileTimeKinds, bool ALocalTime);
	void __fastcall DecrementDate(const TFileTimeKinds& AFileTimeKinds, bool ALocalTime);
	void __fastcall AddDays(const TFileTimeKinds& AFileTimeKinds, bool ALocalTime);
	void __fastcall ResetTime(const TFileTimeKinds& AFileTimeKinds, bool ALocalTime);
	void __fastcall RandomizeTime(const TFileTimeKinds& AFileTimeKinds, bool ALocalTime);
	void __fastcall Undo();
	bool __fastcall CanUndo();
	void __fastcall Redo();
	bool __fastcall CanRedo();
	__property TValueHistory<TFileTimes>* FileTimesHistory = {read=FFileTimesHistory};
	__property TOpenDialog* GetDialog = {read=FGetDialog, write=FGetDialog};
};
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Restamper::EditMan
using namespace Moochos::Restamper::EditMan;
//---------------------------------------------------------------------------
#endif

