//---------------------------------------------------------------------------
// EnterDialogUnit.cpp
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <UtilCls.h>
#include "EnterDialogUnit.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TEnterDialog* EnterDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TEnterDialog::Prepare(const AnsiString& ACaption, const AnsiString& AMessage, AnsiString& AValue)
{
	Caption = ACaption;
	Label1->Caption = AMessage;
	Edit1->Text = AValue;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TEnterDialog::Process()
{
	ActiveControl = NULL;
	SelectFirst();
	if(ShowModal() != mrOk) {
		Abort();
	}
	return Edit1->Text;
}
//---------------------------------------------------------------------------
void __fastcall TEnterDialog::Unprepare()
{
	Edit1->Text = AnsiString();
	Label1->Caption = AnsiString();
	Caption = AnsiString();
}
//---------------------------------------------------------------------------
__fastcall TEnterDialog::TEnterDialog(TComponent* AOwner) :
	TForm(AOwner)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TEnterDialog::~TEnterDialog()
{
	// Do nothing
}
//---------------------------------------------------------------------------
bool __fastcall TEnterDialog::Execute(const AnsiString& ACaption, const AnsiString& AMessage, AnsiString& AValue)
{
	try {
		Prepare(ACaption, AMessage, AValue);
		AValue = Process();
		Unprepare();
	}
	catch(EAbort& e) {
		Unprepare();
		return false;
	}
	catch(...) {
		Unprepare();
		throw;
	}
	return true;
}
//---------------------------------------------------------------------------
bool __fastcall EnterValue(const AnsiString& ACaption, const AnsiString& AMessage, AnsiString& AValue)
{
	TPtr<TEnterDialog> dialog = new TEnterDialog(NULL);
	return dialog->Execute(ACaption, AMessage, AValue);
}
//---------------------------------------------------------------------------

