//---------------------------------------------------------------------------
#ifndef Moochos_Restamper_FileTimeDialogUnit_H
#define Moochos_Restamper_FileTimeDialogUnit_H
//---------------------------------------------------------------------------
// FileTimeDialogUnit.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------
class EFileTimeDialogError : public Exception
{
public:
	__fastcall EFileTimeDialogError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TFileTimeDialog : public TForm
{
__published:
	TButton* Button91;
	TButton* Button92;
	TEdit* Edit11;
	TEdit* Edit12;
	TEdit* Edit13;
	TEdit* Edit21;
	TEdit* Edit22;
	TEdit* Edit23;
	TEdit* Edit24;
	TLabel* Label11;
	TLabel* Label12;
	TLabel* Label13;
	TLabel* Label21;
	TLabel* Label22;
	TLabel* Label23;
	TLabel* Label24;
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
private:
	struct TBackup
	{
		FILETIME FileTime;
	};
	FILETIME FFileTime;
	TBackup FBackup;
	void __fastcall Prepare();
	void __fastcall Unprepare();
	void __fastcall Restore();
	void __fastcall Process();
	void __fastcall SetFileTime(const FILETIME& AFileTime);
protected:
public:
	virtual __fastcall TFileTimeDialog(TComponent* AOwner);
	virtual __fastcall ~TFileTimeDialog();
	bool __fastcall Execute();
	__property FILETIME FileTime = {read=FFileTime, write=SetFileTime};
};
//---------------------------------------------------------------------------
extern PACKAGE TFileTimeDialog* FileTimeDialog;
//---------------------------------------------------------------------------
#endif

