//---------------------------------------------------------------------------
// Lists.cpp
//
// Version: 1.2.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <UtilCls.h>
#include "Lists.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Lists {
//---------------------------------------------------------------------------
void __fastcall AddItems(TList* ASrcList, TList* ADstList)
{
	if(ADstList->Capacity < ADstList->Count + ASrcList->Count) {
		ADstList->Capacity = ADstList->Count + ASrcList->Count;
	}
	for(int i = 0; i < ASrcList->Count; i++) {
		ADstList->Add(ASrcList->Items[i]);
	}
}
//---------------------------------------------------------------------------
void __fastcall Invert(TList* AList)
{
	for(int i = 0; i < AList->Count / 2; i++) {
		AList->Exchange(i, AList->Count - 1 - i);
	}
}
//---------------------------------------------------------------------------
__fastcall TAutoObjectListOwnsObjects::TAutoObjectListOwnsObjects(TObjectList* AList, bool AOwnsObjects) :
	FList(AList),
	FOwnsObjects(AList->OwnsObjects)
{
	FList->OwnsObjects = AOwnsObjects;
}
//---------------------------------------------------------------------------
__fastcall TAutoObjectListOwnsObjects::~TAutoObjectListOwnsObjects()
{
	FList->OwnsObjects = FOwnsObjects;
}
//---------------------------------------------------------------------------
__fastcall TAutoStringsUpdate::TAutoStringsUpdate(TStrings* AList) :
	FList(AList)
{
	FList->BeginUpdate();
}
//---------------------------------------------------------------------------
__fastcall TAutoStringsUpdate::~TAutoStringsUpdate()
{
	FList->EndUpdate();
}
//---------------------------------------------------------------------------
bool __fastcall TryAdd(TStrings* AList, const AnsiString& AString)
{
	return TryAddObject(AList, AString, NULL);
}
//---------------------------------------------------------------------------
bool __fastcall TryAddObject(TStrings* AList, const AnsiString& AString, TObject* AObject)
{
	int oldCount = AList->Count;
	AList->AddObject(AString, AObject);
	return AList->Count > oldCount;
}
//---------------------------------------------------------------------------
void __fastcall Resize(TStrings* AList, int ACount)
{
	if(AList->Count < ACount) {
		if(AList->Capacity < ACount) {
			AList->Capacity = ACount;
		}
		while(AList->Count < ACount) {
			AList->Add(AnsiString());
		}
	}
	else if(AList->Count > ACount) {
		while(AList->Count > ACount) {
			AList->Delete(AList->Count - 1);
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall Pack(TStrings* AList, bool AByString, bool AByObject)
{
	int index = AList->Count;
	while(--index > 0) {
		if(AByString && AList->Strings[index].Length() == 0) {
			AList->Delete(index);
			continue;
		}
		if(AByObject && AList->Objects[index] == NULL) {
			AList->Delete(index);
			continue;
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall Invert(TStrings* AList)
{
	for(int i = 0; i < AList->Count / 2; i++) {
		AList->Exchange(i, AList->Count - 1 - i);
	}
}
//---------------------------------------------------------------------------
AnsiString __fastcall PopFirst(TStrings* AList)
{
	AnsiString first = AList->Strings[0];
	AList->Delete(0);
	return first;
}
//---------------------------------------------------------------------------
AnsiString __fastcall PopLast(TStrings* AList)
{
	AnsiString last = AList->Strings[AList->Count - 1];
	AList->Delete(AList->Count - 1);
	return last;
}
//---------------------------------------------------------------------------
AnsiString __fastcall First(TStrings* AList)
{
	return AList->Strings[0];
}
//---------------------------------------------------------------------------
AnsiString __fastcall Last(TStrings* AList)
{
	return AList->Strings[AList->Count - 1];
}
//---------------------------------------------------------------------------
int __fastcall Find(TStringList* AStrings, const AnsiString& AString)
{
	int index;
	if(!AStrings->Find(AString, index)) {
		return -1;
	}
	return index;
}
//---------------------------------------------------------------------------
}}} // End of Moochos::Moa::Lists
//---------------------------------------------------------------------------

