//---------------------------------------------------------------------------
#ifndef Moochos_Moa_Time_H
#define Moochos_Moa_Time_H
//---------------------------------------------------------------------------
// Time.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moochos { namespace Moa { namespace Time {
//---------------------------------------------------------------------------
class ETimeError : public Exception
{
public:
	__fastcall ETimeError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
// System times
//---------------------------------------------------------------------------
extern SYSTEMTIME __fastcall GetSystemTime();
extern SYSTEMTIME __fastcall MakeSystemTime(WORD AYear, WORD AMonth, WORD ADay, WORD AHour, WORD AMinute, WORD ASecond, WORD AMilliseconds);
extern bool __fastcall IsValidSystemTime(const SYSTEMTIME& ASystemTime);
//---------------------------------------------------------------------------
// File times
//---------------------------------------------------------------------------
extern const DWORDLONG FileTimeIntervalsPerMicrosecond;
extern const DWORDLONG FileTimeIntervalsPerMillisecond;
extern const DWORDLONG FileTimeIntervalsPerSecond;
extern const DWORDLONG FileTimeIntervalsPerMinute;
extern const DWORDLONG FileTimeIntervalsPerHour;
extern const DWORDLONG FileTimeIntervalsPerDay;

extern FILETIME __fastcall SystemTimeToFileTime(const SYSTEMTIME& ASystemTime);
extern FILETIME __fastcall SystemTimeToFileTimeDef(const SYSTEMTIME& ASystemTime, const FILETIME& ADefault);
extern bool __fastcall TrySystemTimeToFileTime(const SYSTEMTIME& ASystemTime, FILETIME& AFileTime);

extern SYSTEMTIME __fastcall FileTimeToSystemTime(const FILETIME& AFileTime);
extern SYSTEMTIME __fastcall FileTimeToSystemTimeDef(const FILETIME& AFileTime, const SYSTEMTIME& ADefault);
extern bool __fastcall TryFileTimeToSystemTime(const FILETIME& AFileTime, SYSTEMTIME& ASystemTime);

extern FILETIME __fastcall ConvertFileTime(const FILETIME& AFileTime, bool AFromLocal, bool AToLocal);
extern FILETIME __fastcall ConvertFileTimeDef(const FILETIME& AFileTime, bool AFromLocal, bool AToLocal, const FILETIME& ADefault);
extern bool __fastcall TryConvertFileTime(const FILETIME& AFileTime, bool AFromLocal, bool AToLocal, FILETIME& ANewFileTime);

extern DWORDLONG __fastcall FileTimeToDwordLong(const FILETIME& AFileTime);
extern FILETIME __fastcall DwordLongToFileTime(DWORDLONG ADwordLong);

extern FILETIME __fastcall MakeFileTime(DWORD ALow, DWORD AHigh);
extern FILETIME __fastcall MakeFileTime(
	WORD AYear,
	WORD AMonth,
	WORD ADay,
	WORD AHour,
	WORD AMinute,
	WORD ASecond,
	WORD AMilliseconds,
	WORD AMicroseconds,
	WORD ANanoseconds);
extern void __fastcall ProcessFileTime(
	const FILETIME& AFileTime,
	WORD& AYear,
	WORD& AMonth,
	WORD& ADay,
	WORD& AHour,
	WORD& AMinute,
	WORD& ASecond,
	WORD& AMilliseconds,
	WORD& AMicroseconds,
	WORD& ANanoseconds);

extern bool __fastcall IsValidFileTime(const FILETIME& AFileTime);
extern bool __fastcall IsUnknownFileTime(const FILETIME& AFileTime);
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Moa::Time
using namespace Moochos::Moa::Time;
//---------------------------------------------------------------------------
#endif

