//---------------------------------------------------------------------------
// MainFormUnit.cpp
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Lib/Moochos/Moa/Shell.h"
#include "MainFormUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm* MainForm = NULL;
//---------------------------------------------------------------------------
void __fastcall TMainForm::ApplicationIdle(TObject* ASender, bool& ADone)
{
	Application->OnIdle = NULL;
	if(ParamCount() == 0) {
		return;
	}
	Application->MessageBox(
		"This application does not accept any parameters at starting time.",
		Application->Title.c_str(),
		MB_OK | MB_ICONWARNING | MB_SETFOREGROUND);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	SettingsMan->Save();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ActionList1Update(TBasicAction* AAction, bool& AHandled)
{
	AHandled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StampFilesAcExecute(TObject* ASender)
{
	StampMan->StampFiles(FileTimeKinds, FileTimes, Options);
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StampDirectoryAcExecute(TObject* ASender)
{
	StampMan->StampDirectory(FileTimeKinds, FileTimes, Options);
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StampListAcExecute(TObject* ASender)
{
	StampMan->StampList(FileTimeKinds, FileTimes, Options);
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StampDroppedFilesAcExecute(TObject* ASender)
{
	AnsiString fileNames = DroppedFiles->Text;
	DroppedFiles->Clear();
	StampMan->Stamp(FileTimeKinds, FileTimes, fileNames, Options);
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StampRestoreAcExecute(TObject* ASender)
{
	StampMan->Restore();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StampOpenOutputDirAcExecute(TObject* ASender)
{
	StampMan->OpenOutputDir();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StampChangeOutputDirAcExecute(TObject* ASender)
{
	StampMan->ChangeOutputDir();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::StampExitAcExecute(TObject* ASender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditUndoAcExecute(TObject* ASender)
{
	EditMan->Undo();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditRedoAcExecute(TObject* ASender)
{
	EditMan->Redo();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditCreatedAcExecute(TObject* ASender)
{
	EditMan->EnterCreated(FileTimeKinds, LocalTime);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditLastModifiedAcExecute(TObject* ASender)
{
	EditMan->EnterLastModified(FileTimeKinds, LocalTime);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditLastAccessedAcExecute(TObject* ASender)
{
	EditMan->EnterLastAccessed(FileTimeKinds, LocalTime);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditAllTimesAcExecute(TObject* ASender)
{
	EditMan->EnterAllTimes(FileTimeKinds, LocalTime);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditGetFromFileAcExecute(TObject* ASender)
{
	EditMan->GetFromFile(FileTimeKinds, LocalTime);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditGetFromDirectoryAcExecute(TObject* ASender)
{
	EditMan->GetFromDir(FileTimeKinds, LocalTime);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditResetToCreatedAcExecute(TObject* ASender)
{
	EditMan->ResetToCreated(FileTimeKinds, LocalTime);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditResetToLastModifiedAcExecute(TObject* ASender)
{
	EditMan->ResetToLastModified(FileTimeKinds, LocalTime);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditResetToLastAccessedAcExecute(TObject* ASender)
{
	EditMan->ResetToLastAccessed(FileTimeKinds, LocalTime);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditSetToNowAcExecute(TObject* ASender)
{
	EditMan->SetToNow(FileTimeKinds, LocalTime);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditIncrementDateAcExecute(TObject* ASender)
{
	EditMan->IncrementDate(FileTimeKinds, LocalTime);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditDecrementDateAcExecute(TObject* ASender)
{
	EditMan->DecrementDate(FileTimeKinds, LocalTime);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditAddDaysAcExecute(TObject* ASender)
{
	EditMan->AddDays(FileTimeKinds, LocalTime);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditResetTimeAcExecute(TObject* ASender)
{
	EditMan->ResetTime(FileTimeKinds, LocalTime);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::EditRandomizeTimeAcExecute(TObject* ASender)
{
	EditMan->RandomizeTime(FileTimeKinds, LocalTime);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ViewToolbarAcExecute(TObject* ASender)
{
	ToolbarVisible = ViewToolbarAc->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ViewStatusBarAcExecute(TObject* ASender)
{
	StatusBarVisible = ViewStatusBarAc->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HelpContentsAcExecute(TObject* ASender)
{
	HelpMan->ShowContents(true);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HelpAboutAcExecute(TObject* ASender)
{
	HelpMan->ShowAbout();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CheckBox11Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CheckBox12Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CheckBox13Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Label11Click(TObject* ASender)
{
	EditCreatedAc->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Label12Click(TObject* ASender)
{
	EditLastModifiedAc->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Label13Click(TObject* ASender)
{
	EditLastAccessedAc->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RadioButton11Click(TObject* ASender)
{
	UpdateFileTimes();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RadioButton12Click(TObject* ASender)
{
	UpdateFileTimes();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Initialize()
{
	try {
		Application->OnIdle = ApplicationIdle;

		FFileTimesHistory = new TValueHistory<TFileTimes>(TFileTimes(SystemTimeToFileTime(GetSystemTime())));
		FileTimesHistory->OnChange = FileTimesHistoryChange;

		FStampMan = new TStampMan();
		FEditMan = new TEditMan(FileTimesHistory);
		FHelpMan = new THelpMan();
		FSettingsMan = new TSettingsMan();

		FDroppedFiles = new TStringList();
		static_cast<TStringList*>(FDroppedFiles)->OnChange = DroppedFilesChange;

		// Surely change the colors
		Label11->Color = clWindow;
		Label12->Color = clWindow;
		Label13->Color = clWindow;

		ToolbarVisible = true;
		StatusBarVisible = true;

		UpdateFileTimes();
		UpdateAccess();

		Status = "Ready";

		SettingsMan->Load();
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Uninitialize()
{
	delete FFileTimesHistory;
	FFileTimesHistory = NULL;

	delete FDroppedFiles;
	FDroppedFiles = NULL;

	delete FSettingsMan;
	FSettingsMan = NULL;

	delete FHelpMan;
	FHelpMan = NULL;

	delete FEditMan;
	FEditMan = NULL;

	delete FStampMan;
	FStampMan = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMDropFiles(TMessage& AMessage)
{
	TFileDrop fileDrop(AMessage);
	SetForegroundWindow(Handle);
	fileDrop.GetFiles(DroppedFiles);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DroppedFilesChange(TObject* ASender)
{
	if(DroppedFiles->Count == 0) {
		return;
	}
	StampDroppedFilesAc->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileTimesHistoryChange(TObject* ASender)
{
	UpdateFileTimes();
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpdateAccess()
{
	TFileTimeKinds fileTimeKinds = FileTimeKinds;
	bool anySelected = !fileTimeKinds.Empty();

	StampFilesAc->Enabled = anySelected;
	StampDirectoryAc->Enabled = anySelected;
	StampListAc->Enabled = anySelected;

	EditUndoAc->Enabled = EditMan->CanUndo();
	EditRedoAc->Enabled = EditMan->CanRedo();
	EditCreatedAc->Enabled = fileTimeKinds.Contains(ftCreationTime);
	EditLastModifiedAc->Enabled = fileTimeKinds.Contains(ftLastWriteTime);
	EditLastAccessedAc->Enabled = fileTimeKinds.Contains(ftLastAccessTime);
	EditAllTimesAc->Enabled = anySelected;
	EditGetFromFileAc->Enabled = anySelected;
	EditGetFromDirectoryAc->Enabled = anySelected;
	EditResetToCreatedAc->Enabled = anySelected;
	EditResetToLastModifiedAc->Enabled = anySelected;
	EditResetToLastAccessedAc->Enabled = anySelected;
	EditSetToNowAc->Enabled = anySelected;
	EditIncrementDateAc->Enabled = anySelected;
	EditDecrementDateAc->Enabled = anySelected;
	EditAddDaysAc->Enabled = anySelected;
	EditResetTimeAc->Enabled = anySelected;
	EditRandomizeTimeAc->Enabled = anySelected;

	DragAcceptFiles(Handle, anySelected);
	Label11->Enabled = EditCreatedAc->Enabled;
	Label12->Enabled = EditLastModifiedAc->Enabled;
	Label13->Enabled = EditLastAccessedAc->Enabled;
	RadioButton11->Enabled = anySelected;
	RadioButton12->Enabled = anySelected;
	CheckBox21->Enabled = anySelected;
	CheckBox22->Enabled = anySelected;
	CheckBox23->Enabled = anySelected;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpdateFileTimes()
{
	Label11->Caption = FileTimeToStr(FileTimes.Items[ftCreationTime], LocalTime);
	Label12->Caption = FileTimeToStr(FileTimes.Items[ftLastWriteTime], LocalTime);
	Label13->Caption = FileTimeToStr(FileTimes.Items[ftLastAccessTime], LocalTime);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMainForm::FileTimeToStr(const FILETIME& AFileTime, bool ALocalTime)
{
	static const AnsiString stringForError = "(Error)";

	AnsiString resultString;
	try {
		WORD parts[9] = {0};
		ProcessFileTime(
			ConvertFileTime(AFileTime, false, ALocalTime),
			parts[0],
			parts[1],
			parts[2],
			parts[3],
			parts[4],
			parts[5],
			parts[6],
			parts[7],
			parts[8]);
		resultString = AnsiString().sprintf(
			"%04u-%02u-%02u %02u:%02u:%02u.%03u%03u%u",
			parts[0],
			parts[1],
			parts[2],
			parts[3],
			parts[4],
			parts[5],
			parts[6],
			parts[7],
			parts[8] / 100);
	}
	catch(EConvertError& e) {
		return stringForError;
	}
	return resultString;
}
//---------------------------------------------------------------------------
TFileTimeKinds __fastcall TMainForm::GetFileTimeKinds()
{
	TFileTimeKinds fileTimeKinds;
	if(CheckBox11->Checked) {
		fileTimeKinds << ftCreationTime;
	}
	if(CheckBox12->Checked) {
		fileTimeKinds << ftLastWriteTime;
	}
	if(CheckBox13->Checked) {
		fileTimeKinds << ftLastAccessTime;
	}
	return fileTimeKinds;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetFileTimeKinds(const TFileTimeKinds& AFileTimeKinds)
{
	CheckBox11->Checked = AFileTimeKinds.Contains(ftCreationTime);
	CheckBox12->Checked = AFileTimeKinds.Contains(ftLastWriteTime);
	CheckBox13->Checked = AFileTimeKinds.Contains(ftLastAccessTime);
}
//---------------------------------------------------------------------------
TFileTimes __fastcall TMainForm::GetFileTimes()
{
	return FileTimesHistory->Current;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetFileTimes(const TFileTimes& AFileTimes)
{
	FileTimesHistory->Reset(AFileTimes);
}
//---------------------------------------------------------------------------
TStampTaskOptions __fastcall TMainForm::GetOptions()
{
	TStampTaskOptions options;
	if(CheckBox21->Checked) {
		options << stIncludeSubdirectories;
	}
	if(CheckBox22->Checked) {
		options << stExcludeDirectories;
	}
	if(CheckBox23->Checked) {
		options << stRemoveReadOnlyAttr;
	}
	return options;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetOptions(const TStampTaskOptions& AOptions)
{
	CheckBox21->Checked = AOptions.Contains(stIncludeSubdirectories);
	CheckBox22->Checked = AOptions.Contains(stExcludeDirectories);
	CheckBox23->Checked = AOptions.Contains(stRemoveReadOnlyAttr);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMainForm::GetStatus()
{
	return StatusBar1->SimpleText;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetStatus(const AnsiString& AStatus)
{
	StatusBar1->SimpleText = AStatus;
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::GetLocalTime()
{
	if(RadioButton11->Checked) {
		return false;
	}
	else if(RadioButton12->Checked) {
		return true;
	}
	else {
		throw EMainFormError("Specify whether to use the local time or not.");
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetLocalTime(bool ALocalTime)
{
	if(ALocalTime) {
		RadioButton12->Checked = true;
	}
	else {
		RadioButton11->Checked = true;
	}
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::GetToolbarVisible()
{
	return ToolBar1->Visible;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetToolbarVisible(bool AToolbarVisible)
{
	ToolBar1->Visible = AToolbarVisible;
	ViewToolbarAc->Checked = ToolbarVisible;
}
//---------------------------------------------------------------------------
bool __fastcall TMainForm::GetStatusBarVisible()
{
	return StatusBar1->Visible;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetStatusBarVisible(bool AStatusBarVisible)
{
	StatusBar1->Visible = AStatusBarVisible;
	ViewStatusBarAc->Checked = StatusBarVisible;
}
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* AOwner) :
	TForm(AOwner),
	FStampMan(NULL),
	FEditMan(NULL),
	FHelpMan(NULL),
	FSettingsMan(NULL),
	FDroppedFiles(NULL),
	FFileTimesHistory(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TMainForm::~TMainForm()
{
	Uninitialize();
}
//---------------------------------------------------------------------------

