//---------------------------------------------------------------------------
#ifndef Moochos_Restamper_MainFormUnit_H
#define Moochos_Restamper_MainFormUnit_H
//---------------------------------------------------------------------------
// MainFormUnit.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <ActnList.hpp>
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <StdCtrls.hpp>
#include <ToolWin.hpp>
#include "Lib/Moochos/Moa/Files.h"
#include "Lib/Moochos/Moa/Histories.h"
#include "Lib/Moochos/Moa/Time.h"
#include "EditMan.h"
#include "HelpMan.h"
#include "SettingsMan.h"
#include "StampMan.h"
//---------------------------------------------------------------------------
class EMainFormError : public Exception
{
public:
	__fastcall EMainFormError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:
	TActionList* ActionList1;
	TAction* StampFilesAc;
	TAction* StampDirectoryAc;
	TAction* StampListAc;
	TAction* StampDroppedFilesAc;
	TAction* StampRestoreAc;
	TAction* StampOpenOutputDirAc;
	TAction* StampChangeOutputDirAc;
	TAction* StampExitAc;
	TAction* EditUndoAc;
	TAction* EditRedoAc;
	TAction* EditCreatedAc;
	TAction* EditLastModifiedAc;
	TAction* EditLastAccessedAc;
	TAction* EditAllTimesAc;
	TAction* EditGetFromFileAc;
	TAction* EditGetFromDirectoryAc;
	TAction* EditResetToCreatedAc;
	TAction* EditResetToLastModifiedAc;
	TAction* EditResetToLastAccessedAc;
	TAction* EditSetToNowAc;
	TAction* EditIncrementDateAc;
	TAction* EditDecrementDateAc;
	TAction* EditAddDaysAc;
	TAction* EditResetTimeAc;
	TAction* EditRandomizeTimeAc;
	TAction* ViewToolbarAc;
	TAction* ViewStatusBarAc;
	TAction* HelpContentsAc;
	TAction* HelpAboutAc;
	TCheckBox* CheckBox11;
	TCheckBox* CheckBox12;
	TCheckBox* CheckBox13;
	TCheckBox* CheckBox21;
	TCheckBox* CheckBox22;
	TCheckBox* CheckBox23;
	TGroupBox* GroupBox21;
	TImageList* ImageList1;
	TLabel* Label11;
	TLabel* Label12;
	TLabel* Label13;
	TMainMenu* MainMenu1;
	TMenuItem* MenuItem11;
	TMenuItem* MenuItem111;
	TMenuItem* MenuItem112;
	TMenuItem* MenuItem113;
	TMenuItem* MenuItem114;
	TMenuItem* MenuItem115;
	TMenuItem* MenuItem116;
	TMenuItem* MenuItem117;
	TMenuItem* MenuItem1171;
	TMenuItem* MenuItem1172;
	TMenuItem* MenuItem118;
	TMenuItem* MenuItem119;
	TMenuItem* MenuItem12;
	TMenuItem* MenuItem121;
	TMenuItem* MenuItem122;
	TMenuItem* MenuItem123;
	TMenuItem* MenuItem124;
	TMenuItem* MenuItem125;
	TMenuItem* MenuItem126;
	TMenuItem* MenuItem127;
	TMenuItem* MenuItem128;
	TMenuItem* MenuItem129;
	TMenuItem* MenuItem1291;
	TMenuItem* MenuItem1292;
	TMenuItem* MenuItem12A;
	TMenuItem* MenuItem12A1;
	TMenuItem* MenuItem12A2;
	TMenuItem* MenuItem12A3;
	TMenuItem* MenuItem12B;
	TMenuItem* MenuItem12C;
	TMenuItem* MenuItem12D;
	TMenuItem* MenuItem12D1;
	TMenuItem* MenuItem12D2;
	TMenuItem* MenuItem12D3;
	TMenuItem* MenuItem12E;
	TMenuItem* MenuItem12E1;
	TMenuItem* MenuItem12E2;
	TMenuItem* MenuItem13;
	TMenuItem* MenuItem131;
	TMenuItem* MenuItem132;
	TMenuItem* MenuItem14;
	TMenuItem* MenuItem141;
	TMenuItem* MenuItem142;
	TMenuItem* MenuItem143;
	TPanel* Panel1;
	TRadioButton* RadioButton11;
	TRadioButton* RadioButton12;
	TStatusBar* StatusBar1;
	TToolBar* ToolBar1;
	TToolButton* ToolButton1;
	TToolButton* ToolButton2;
	TToolButton* ToolButton3;
	TToolButton* ToolButton4;
	TToolButton* ToolButton5;
	TToolButton* ToolButton6;
	TToolButton* ToolButton7;
	TToolButton* ToolButton8;
	TToolButton* ToolButton9;
	TToolButton* ToolButtonA;
	TToolButton* ToolButtonB;
	void __fastcall ApplicationIdle(TObject* ASender, bool& ADone);
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
	void __fastcall ActionList1Update(TBasicAction* AAction, bool& AHandled);
	void __fastcall StampFilesAcExecute(TObject* ASender);
	void __fastcall StampDirectoryAcExecute(TObject* ASender);
	void __fastcall StampListAcExecute(TObject* ASender);
	void __fastcall StampDroppedFilesAcExecute(TObject* ASender);
	void __fastcall StampRestoreAcExecute(TObject* ASender);
	void __fastcall StampOpenOutputDirAcExecute(TObject* ASender);
	void __fastcall StampChangeOutputDirAcExecute(TObject* ASender);
	void __fastcall StampExitAcExecute(TObject* ASender);
	void __fastcall EditUndoAcExecute(TObject* ASender);
	void __fastcall EditRedoAcExecute(TObject* ASender);
	void __fastcall EditCreatedAcExecute(TObject* ASender);
	void __fastcall EditLastModifiedAcExecute(TObject* ASender);
	void __fastcall EditLastAccessedAcExecute(TObject* ASender);
	void __fastcall EditAllTimesAcExecute(TObject* ASender);
	void __fastcall EditGetFromFileAcExecute(TObject* ASender);
	void __fastcall EditGetFromDirectoryAcExecute(TObject* ASender);
	void __fastcall EditResetToCreatedAcExecute(TObject* ASender);
	void __fastcall EditResetToLastModifiedAcExecute(TObject* ASender);
	void __fastcall EditResetToLastAccessedAcExecute(TObject* ASender);
	void __fastcall EditSetToNowAcExecute(TObject* ASender);
	void __fastcall EditIncrementDateAcExecute(TObject* ASender);
	void __fastcall EditDecrementDateAcExecute(TObject* ASender);
	void __fastcall EditAddDaysAcExecute(TObject* ASender);
	void __fastcall EditResetTimeAcExecute(TObject* ASender);
	void __fastcall EditRandomizeTimeAcExecute(TObject* ASender);
	void __fastcall ViewToolbarAcExecute(TObject* ASender);
	void __fastcall ViewStatusBarAcExecute(TObject* ASender);
	void __fastcall HelpContentsAcExecute(TObject* ASender);
	void __fastcall HelpAboutAcExecute(TObject* ASender);
	void __fastcall CheckBox11Click(TObject* ASender);
	void __fastcall CheckBox12Click(TObject* ASender);
	void __fastcall CheckBox13Click(TObject* ASender);
	void __fastcall Label11Click(TObject* ASender);
	void __fastcall Label12Click(TObject* ASender);
	void __fastcall Label13Click(TObject* ASender);
	void __fastcall RadioButton11Click(TObject* ASender);
	void __fastcall RadioButton12Click(TObject* ASender);
private:
	TStampMan* FStampMan;
	TEditMan* FEditMan;
	THelpMan* FHelpMan;
	TSettingsMan* FSettingsMan;
	TStrings* FDroppedFiles;
	TValueHistory<TFileTimes>* FFileTimesHistory;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall DroppedFilesChange(TObject* ASender);
	void __fastcall FileTimesHistoryChange(TObject* ASender);
	void __fastcall WMDropFiles(TMessage& AMessage);
	void __fastcall UpdateAccess();
	void __fastcall UpdateFileTimes();
	AnsiString __fastcall FileTimeToStr(const FILETIME& AFileTime, bool ALocalTime);
	TFileTimeKinds __fastcall GetFileTimeKinds();
	void __fastcall SetFileTimeKinds(const TFileTimeKinds& AFileTimeKinds);
	TFileTimes __fastcall GetFileTimes();
	void __fastcall SetFileTimes(const TFileTimes& AFileTimes);
	TStampTaskOptions __fastcall GetOptions();
	void __fastcall SetOptions(const TStampTaskOptions& AOptions);
	AnsiString __fastcall GetStatus();
	void __fastcall SetStatus(const AnsiString& AStatus);
	bool __fastcall GetLocalTime();
	void __fastcall SetLocalTime(bool ALocalTime);
	bool __fastcall GetToolbarVisible();
	void __fastcall SetToolbarVisible(bool AToolbarVisible);
	bool __fastcall GetStatusBarVisible();
	void __fastcall SetStatusBarVisible(bool AStatusBarVisible);
protected:
public:
	virtual __fastcall TMainForm(TComponent* AOwner);
	virtual __fastcall ~TMainForm();
	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_DROPFILES, TMessage, WMDropFiles);
	END_MESSAGE_MAP(TForm);
	__property TStampMan* StampMan = {read=FStampMan};
	__property TEditMan* EditMan = {read=FEditMan};
	__property THelpMan* HelpMan = {read=FHelpMan};
	__property TSettingsMan* SettingsMan = {read=FSettingsMan};
	__property TStrings* DroppedFiles = {read=FDroppedFiles};
	__property TFileTimeKinds FileTimeKinds = {read=GetFileTimeKinds, write=SetFileTimeKinds};
	__property TFileTimes FileTimes = {read=GetFileTimes, write=SetFileTimes};
	__property TValueHistory<TFileTimes>* FileTimesHistory = {read=FFileTimesHistory};
	__property TStampTaskOptions Options = {read=GetOptions, write=SetOptions};
	__property AnsiString Status = {read=GetStatus, write=SetStatus};
	__property bool LocalTime = {read=GetLocalTime, write=SetLocalTime};
	__property bool ToolbarVisible = {read=GetToolbarVisible, write=SetToolbarVisible};
	__property bool StatusBarVisible = {read=GetStatusBarVisible, write=SetStatusBarVisible};
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm* MainForm;
//---------------------------------------------------------------------------
#endif

