//---------------------------------------------------------------------------
// ProgressDialogUnit.cpp
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "ProgressDialogUnit.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TProgressDialog* ProgressDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::Button1Click(TObject* ASender)
{
	Cancel();
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::UpdateAccess()
{
	Button1->Enabled = IsBusy();
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::WMExecute(TMessage& AMessage)
{
	if(!IsBusy()) {
		return;
	}
	DoExecute();
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::DoExecute()
{
	if(OnExecute != NULL) {
		OnExecute(this);
	}
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::DoCancel()
{
	if(OnCancel != NULL) {
		OnCancel(this);
	}
}
//---------------------------------------------------------------------------
TProgressDialog::TTaskStates __fastcall TProgressDialog::GetTaskState()
{
	return FTaskState;
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::SetTaskState(const TTaskStates& ATaskState)
{
	if(ATaskState == TaskState) {
		return;
	}
	FTaskState = ATaskState;
	UpdateAccess();
}
//---------------------------------------------------------------------------
AnsiString __fastcall TProgressDialog::GetMessage()
{
	return Label1->Caption;
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::SetMessage(const AnsiString& AMessage)
{
	Label1->Caption = AMessage;
}
//---------------------------------------------------------------------------
int __fastcall TProgressDialog::GetProgress()
{
	return ProgressBar1->Position;
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::SetProgress(int AProgress)
{
	ProgressBar1->Position = AProgress;
}
//---------------------------------------------------------------------------
__fastcall TProgressDialog::TProgressDialog(TComponent* AOwner) :
	TForm(AOwner),
	FTaskState(),
	FOnExecute(NULL),
	FOnCancel(NULL)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
__fastcall TProgressDialog::~TProgressDialog()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::Execute()
{
	if(TaskState.Contains(tsStarted)) {
		return;
	}
	PostMessage(Handle, WM_EXECUTE, 0, 0);
	TaskState = TTaskStates() << tsStarted;
	SelectFirst();
	ShowModal();
	TaskState = TTaskStates();
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::Finish()
{
	if(!IsBusy()) {
		return;
	}
	TaskState = TaskState << tsEnded;
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::Cancel()
{
	if(!IsBusy()) {
		return;
	}
	DoCancel();
}
//---------------------------------------------------------------------------
void __fastcall TProgressDialog::CloseDialog()
{
	ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
bool __fastcall TProgressDialog::IsBusy()
{
	return TaskState.Contains(tsStarted) && !TaskState.Contains(tsEnded);
}
//---------------------------------------------------------------------------
bool __fastcall TProgressDialog::CloseQuery()
{
	if(IsBusy()) {
		Cancel();
		return false;
	}
	return TForm::CloseQuery();
}
//---------------------------------------------------------------------------

