//---------------------------------------------------------------------------
#ifndef Moochos_Restamper_ProgressDialogUnit_H
#define Moochos_Restamper_ProgressDialogUnit_H
//---------------------------------------------------------------------------
// ProgressDialogUnit.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------
class TProgressDialog : public TForm
{
__published:
	TButton* Button1;
	TLabel* Label1;
	TProgressBar* ProgressBar1;
	void __fastcall Button1Click(TObject* ASender);
private:
	static const UINT WM_EXECUTE = WM_APP + 0;
	enum TTaskState
	{
		tsStarted,
		tsEnded,
	};
	typedef Set<TTaskState, tsStarted, tsEnded> TTaskStates;
	TTaskStates FTaskState;
	TNotifyEvent FOnExecute;
	TNotifyEvent FOnCancel;
	void __fastcall UpdateAccess();
	void __fastcall WMExecute(TMessage& AMessage);
	void __fastcall DoExecute();
	void __fastcall DoCancel();
	TTaskStates __fastcall GetTaskState();
	void __fastcall SetTaskState(const TTaskStates& ATaskState);
	AnsiString __fastcall GetMessage();
	void __fastcall SetMessage(const AnsiString& AMessage);
	int __fastcall GetProgress();
	void __fastcall SetProgress(int AProgress);
	__property TTaskStates TaskState = {read=GetTaskState, write=SetTaskState};
protected:
public:
	virtual __fastcall TProgressDialog(TComponent* AOwner);
	virtual __fastcall ~TProgressDialog();
	void __fastcall Execute();
	void __fastcall Finish();
	void __fastcall Cancel();
	void __fastcall CloseDialog();
	bool __fastcall IsBusy();
	virtual bool __fastcall CloseQuery();
	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_EXECUTE, TMessage, WMExecute);
	END_MESSAGE_MAP(TForm)
	__property AnsiString Message = {read=GetMessage, write=SetMessage};
	__property int Progress = {read=GetProgress, write=SetProgress};
	__property TNotifyEvent OnExecute = {read=FOnExecute, write=FOnExecute};
	__property TNotifyEvent OnCancel = {read=FOnCancel, write=FOnCancel};
};
//---------------------------------------------------------------------------
extern PACKAGE TProgressDialog* ProgressDialog;
//---------------------------------------------------------------------------
#endif

