//---------------------------------------------------------------------------
// Stamp.cpp
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <UtilCls.h>
#include "Lib/Moochos/Moa/Sets.h"
#include "Stamp.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moochos { namespace Restamper { namespace Stamp {
//---------------------------------------------------------------------------
AnsiString __fastcall StampCommandArgsToStr(const TStampCommandArgs& AStampCommandArgs)
{
	static const AnsiString HexPrefix = "0x";

	TPtr<TStrings> record = new TStringList();
	record->Capacity = 7;
	record->Add(SetToStr(AStampCommandArgs.FileTimeKinds));
	record->Add(HexPrefix + IntToHex(static_cast<__int64>(FileTimeToDwordLong(AStampCommandArgs.FileTimes.Items[ftCreationTime])), 1));
	record->Add(HexPrefix + IntToHex(static_cast<__int64>(FileTimeToDwordLong(AStampCommandArgs.FileTimes.Items[ftLastWriteTime])), 1));
	record->Add(HexPrefix + IntToHex(static_cast<__int64>(FileTimeToDwordLong(AStampCommandArgs.FileTimes.Items[ftLastAccessTime])), 1));
	record->Add(AStampCommandArgs.FileName);
	record->Add(BoolToStr(AStampCommandArgs.RemoveReadOnlyAttr));
	record->Add(AnsiString()); // Add a terminator
	return record->CommaText;
}
//---------------------------------------------------------------------------
TStampCommandArgs __fastcall StrToStampCommandArgs(const AnsiString& AString)
{
	TStampCommandArgs stampCommandArgs;
	try {
		TPtr<TStrings> record = new TStringList();
		record->CommaText = AString;
		int index = -1;
		stampCommandArgs.FileTimeKinds = StrToSet(record->Strings[++index], static_cast<TFileTimeKinds*>(NULL));
		stampCommandArgs.FileTimes.Items[ftCreationTime] = DwordLongToFileTime(StrToInt64(record->Strings[++index]));
		stampCommandArgs.FileTimes.Items[ftLastWriteTime] = DwordLongToFileTime(StrToInt64(record->Strings[++index]));
		stampCommandArgs.FileTimes.Items[ftLastAccessTime] = DwordLongToFileTime(StrToInt64(record->Strings[++index]));
		stampCommandArgs.FileName = record->Strings[++index];
		stampCommandArgs.RemoveReadOnlyAttr = StrToBool(record->Strings[++index]);
	}
	catch(EConvertError& e) {
		throw EConvertError("The program cannot convert a string to stamp command arguments");
	}
	catch(EListError& e) {
		throw EConvertError("The program cannot convert a string to stamp command arguments");
	}
	return stampCommandArgs;
}
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Restamper::Stamp
//---------------------------------------------------------------------------

