//---------------------------------------------------------------------------
#ifndef Moochos_Restamper_StampCommon_H
#define Moochos_Restamper_StampCommon_H
//---------------------------------------------------------------------------
// StampCommon.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "Lib/Moochos/Moa/Files.h"
#include "Lib/Moochos/Moa/Time.h"
//---------------------------------------------------------------------------
namespace Moochos { namespace Restamper { namespace Stamp {
//---------------------------------------------------------------------------
class EStampError : public Exception
{
public:
	__fastcall EStampError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
enum TStampTaskOption
{
	stRestore,
	stIncludeSubdirectories,
	stExcludeDirectories,
	stRemoveReadOnlyAttr,
};
typedef Set<TStampTaskOption, stRestore, stRemoveReadOnlyAttr> TStampTaskOptions;
//---------------------------------------------------------------------------
struct TStampTaskArgs
{
	AnsiString FileNames;
	TFileTimeKinds FileTimeKinds;
	TFileTimes FileTimes;
	AnsiString SourceFileName;
	AnsiString BackupFileName;
	AnsiString LogFileName;
	TStampTaskOptions Options;
};
//---------------------------------------------------------------------------
struct TStampCommandArgs
{
	AnsiString FileName;
	TFileTimeKinds FileTimeKinds;
	TFileTimes FileTimes;
	bool RemoveReadOnlyAttr;
};
//---------------------------------------------------------------------------
extern AnsiString __fastcall StampCommandArgsToStr(const TStampCommandArgs& AStampCommandArgs);
extern TStampCommandArgs __fastcall StrToStampCommandArgs(const AnsiString& AString);
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Restamper::Stamp
using namespace Moochos::Restamper::Stamp;
//---------------------------------------------------------------------------
#endif

