//---------------------------------------------------------------------------
#ifndef Moochos_Restamper_StampMan_H
#define Moochos_Restamper_StampMan_H
//---------------------------------------------------------------------------
// StampMan.h
//
// Version: 1.0.0
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <FileCtrl.hpp>
#include "StampTask.h"
//---------------------------------------------------------------------------
namespace Moochos { namespace Restamper { namespace StampMan {
//---------------------------------------------------------------------------
class EStampManError : public Exception
{
public:
	__fastcall EStampManError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TStampMan : public TObject
{
private:
	AnsiString FOutputDir;
	TStampTask* FTask;
	int FTaskIndex;
	bool FTaskCanceling;
	TOpenDialog* FFilesDialog;
	TOpenDialog* FListDialog;
	TOpenDialog* FRestoreDialog;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall CreateTaskDir(AnsiString& ALogFileName, AnsiString& ABackupFileName);
	void __fastcall Stamp(const TStampTaskArgs& AArgs);
	void __fastcall ReportTaskResults(const TStampTaskArgs& AArgs, int AWarningCount, int AErrorCount);
	void __fastcall TaskStart(TObject* ASender);
	void __fastcall TaskEnd(TObject* ASender);
	void __fastcall TaskStatus(TObject* ASender, const AnsiString& AMessage);
	void __fastcall TaskProgress(TObject* ASender);
	void __fastcall TaskCancel(TObject* ASender);
	void __fastcall TaskIdle(TObject* ASender);
	void __fastcall TaskException(TObject* ASender, Exception* AException);
	void __fastcall ProgressDialogExecute(TObject* ASender);
	void __fastcall ProgressDialogCancel(TObject* ASender);
protected:
public:
	__fastcall TStampMan();
	virtual __fastcall ~TStampMan();
	void __fastcall StampFiles(const TFileTimeKinds AFileTimeKinds, const TFileTimes& AFileTimes, const TStampTaskOptions& AOptions);
	void __fastcall StampDirectory(const TFileTimeKinds AFileTimeKinds, const TFileTimes& AFileTimes, const TStampTaskOptions& AOptions);
	void __fastcall StampList(const TFileTimeKinds AFileTimeKinds, const TFileTimes& AFileTimes, const TStampTaskOptions& AOptions);
	void __fastcall Stamp(const TFileTimeKinds AFileTimeKinds, const TFileTimes& AFileTimes, const AnsiString& AFileNames, const TStampTaskOptions& AOptions);
	void __fastcall Restore();
	void __fastcall OpenOutputDir();
	void __fastcall ChangeOutputDir();
	__property AnsiString OutputDir = {read=FOutputDir, write=FOutputDir};
	__property int TaskIndex = {read=FTaskIndex, write=FTaskIndex};
	__property TOpenDialog* FilesDialog = {read=FFilesDialog};
	__property TOpenDialog* ListDialog = {read=FListDialog};
	__property TOpenDialog* RestoreDialog = {read=FRestoreDialog};
};
//---------------------------------------------------------------------------
}}} // End of namespace Moochos::Restamper::StampMan
using namespace Moochos::Restamper::StampMan;
//---------------------------------------------------------------------------
#endif

